classification
Title: pyexpat.c calls trace function incorrectly for exceptions
Type: behavior Stage: test needed
Components: XML Versions: Python 3.4, Python 3.2, Python 3.3, Python 2.7
process
Status: closed Resolution: duplicate
Dependencies: Superseder: Modules/pyexpat.c violates PEP 384
View: 22462
Assigned To: Nosy List: Jeremy.Hylton, ezio.melotti, fdrake, georg.brandl, loewis, nedbat
Priority: normal Keywords: patch

Created on 2009-06-28 22:43 by nedbat, last changed 2014-10-06 13:08 by georg.brandl. This issue is now closed.

Files
File name Uploaded Description Edit
domshow.py nedbat, 2009-06-28 22:43 Demonstration code.
6539.patch nedbat, 2013-04-20 14:01 review
Messages (6)
msg89798 - (view) Author: Ned Batchelder (nedbat) * Date: 2009-06-28 22:43
Pyexpat.c calls the tracing function explicitly (not sure why).  When it
intercepts an exception, it calls the function with PyTrace_EXCEPTION,
but then leaves the scope without calling PyTrace_RETURN.  This is
incorrect.  There should always be a PyTrace_RETURN for every PyTrace_CALL.

I've attached domshow.py to demonstrate the problem.

Running it produces many lines of output, including:

                     line expatbuilder.py 222
                     line expatbuilder.py 223
                     call pyexpat.c 905
                        call expatbuilder.py 892
                           line expatbuilder.py 894
                           line expatbuilder.py 900
                           exception expatbuilder.py 900
                           return expatbuilder.py 900
                        exception pyexpat.c 905
                        exception expatbuilder.py 223
                        line expatbuilder.py 225
                        line expatbuilder.py 226

The exception at line 905 in pyexpat.c should be followed with a return
from line 905 in pyexpat.c, but is not.  After that exception, the
nesting is off by one because the Calls and Returns don't match.
msg175234 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2012-11-09 13:38
Can you provide a patch?
msg175246 - (view) Author: Ned Batchelder (nedbat) * Date: 2012-11-09 16:00
I have no idea why pyexpat.c invokes the trace function in the first place.  Unless someone can explain why it does that when no other C extension does, my inclination would be to make it stop calling the trace function at all, not to fix how it calls it.
msg182723 - (view) Author: Ezio Melotti (ezio.melotti) * (Python committer) Date: 2013-02-23 07:46
The relevant changesets are 1c26eb768293 and e43126c470a7. See also #534864.
msg187426 - (view) Author: Ned Batchelder (nedbat) * Date: 2013-04-20 14:01
Attached a patch which simply removes the code that invokes the trace function.
msg228679 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2014-10-06 13:08
A more complete patch that also fixes up pyexpat's frame trickery is tracked in #22462.
History
Date User Action Args
2014-10-06 13:08:08georg.brandlsetstatus: open -> closed

nosy: + georg.brandl
messages: + msg228679

superseder: Modules/pyexpat.c violates PEP 384
resolution: duplicate
2013-04-20 14:01:27nedbatsetfiles: + 6539.patch
keywords: + patch
messages: + msg187426
2013-02-23 07:46:00ezio.melottisetnosy: + fdrake, Jeremy.Hylton
messages: + msg182723
2012-11-09 16:00:27nedbatsetmessages: + msg175246
2012-11-09 13:38:33ezio.melottisetnosy: + ezio.melotti

messages: + msg175234
versions: + Python 3.3, Python 3.4, - Python 3.1
2010-07-10 23:33:19BreamoreBoysetnosy: + loewis
stage: test needed

versions: + Python 3.1, Python 2.7, Python 3.2, - Python 2.6, Python 2.5
2009-06-28 22:43:21nedbatcreate